from request import Request
from response import Response
import errors
from static_responder import StaticResponder

import socketserver

from controllers.pages import PagesController
from controllers.posts import PostsController
from errors import not_found


from errors import not_found
from router import Router

#REST RESTfull

#CRUDL - Create, Read, Update, Delete, List
#/posts
#GET - /posts
#GET - /posts/{id}
#POST - /posts
#PUT\PATH - /posts/{id}
#DELETE - /posts/{id}

router = Router()
router.get('/', PagesController, 'home')
router.get('/about', PagesController, 'about')
router.get('/posts', PostsController, 'get_list')


class Handler(socketserver.StreamRequestHandler):
    # self.request - client socket
    
    def handle(self):
        request = Request(self.rfile)
        response = Response(self.wfile)
        response.add_header('Connection', 'close')
        # static_responder = StaticResponder(request, response)

        print(request)

        router.run(request, response)

        response.send()
        

ADDRESS = ('localhost', 1027)
socketserver.ThreadingTCPServer.allow_reuse_address = True

with socketserver.ThreadingTCPServer(ADDRESS, Handler) as server:
    server.serve_forever()
